=== sdk/libraries/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a library, just add a subdirectory (the application name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_library() macro appropriately


# add the library in the dependencies order
camitk_add_subdirectory(extensiongenerator)
camitk_add_subdirectory(qtpropertybrowser)
camitk_add_subdirectory(core)
camitk_add_subdirectory(cepcoreschema)
camitk_add_subdirectory(cepgenerator)
camitk_add_subdirectory(python)
