=== sdk/viewers/CMakeLists.txt ===
# add viewer manually as the dependencies does not depend on the alphabetical order
# and this does not seem to be recognize automatically by CMake

# independent viewers
camitk_add_subdirectory(actionviewer)
camitk_add_subdirectory(componentexplorer)
camitk_add_subdirectory(propertyexplorer)
camitk_add_subdirectory(transformationexplorer)

# 3D viewers by order of dependencies
camitk_add_subdirectory(interactivegeometryviewer)
camitk_add_subdirectory(interactivesliceviewer)
camitk_add_subdirectory(medicalimageviewer)
camitk_add_subdirectory(bitmap)
