=== tutorials/viewers/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a viewer, just add a subdirectory (the viewer name is the
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_extension(VIEWER_EXTENSION ...) macro appropriately

# find components
get_subdirectories(VIEWERS_LIST)


# Add subdirectories in CMake project
foreach(VIEWER_NAME ${VIEWERS_LIST})
  camitk_add_subdirectory(${VIEWER_NAME})
endforeach()
