=== imaging/actions/totalsegmentator/CMakeLists.txt ===
camitk_add_subdirectory(actions)
