=== debian/changelog ===
camitk (6.0.0-3) unstable; urgency=medium

  * Minor user issue fixed: due to the new extension system,
    libcamitk-dev should always be installed with camitk-imp so that
    the tools needed to create and load extensions are available.
    Adding this to the debian/control file.
   * Patching a .desktop file to fix Appstream error

 -- Manik Bhattacharjee <manik.bhattacharjee@univ-grenoble-alpes.fr>  Tue, 10 Feb 2026 18:52:08 +0100

camitk (6.0.0-2) unstable; urgency=medium

  * Installation from experimental tested successfully, minor UI issue fixed
    in new patch, hopefully ready to switch to unstable

 -- Manik Bhattacharjee <manik.bhattacharjee@univ-grenoble-alpes.fr>  Tue, 20 Jan 2026 19:20:04 +0100

camitk (6.0.0-1) experimental; urgency=medium

  * New upstream version 6.0.0 (Closes: #1117520)

 -- Manik Bhattacharjee <manik.bhattacharjee@univ-grenoble-alpes.fr>  Wed, 14 Jan 2026 10:27:12 +0100

camitk (5.2.0-5) unstable; urgency=medium

  * Adding safeguards around ctest instructions. (Closes: #1103471)

 -- Emmanuel Promayon <Emmanuel.Promayon@univ-grenoble-alpes.fr>  Sat, 19 Apr 2025 17:23:55 +0200

camitk (5.2.0-4) unstable; urgency=medium

  * use VTK9 modules to remove unneeded java dependencies
  * remove doxygen xml output to improve reproducibility
  * fix dh_missing and patch format warnings

 -- Emmanuel Promayon <Emmanuel.Promayon@univ-grenoble-alpes.fr>  Sat, 15 Mar 2025 14:05:12 +0100
