=== debian/tests/control ===
# see https://people.debian.org/~eriberto/README.package-tests.html for the syntax
Tests: config-test.sh, cepgenerator-test.sh, extensiongenerator-test.sh
# libgl1-mesa-dri and dbus are needed just to avoid warnings that confuse the config test
# g++ is needed to compile the C++ code generated by cepgenerator in the wizard test
Depends: libcamitk-dev, g++, dbus, libgl1-mesa-dri
# this restriction is needed to avoid test abortion due to output to stderr
Restrictions: allow-stderr
