=== debian/watch ===
Version: 5

Source: https://gricad-gitlab.univ-grenoble-alpes.fr/CamiTK/CamiTK.git
Matching-Pattern: refs/tags/@ANY_VERSION@
Mode: git
